(function () {
    "use strict";

    angular.module('core').controller('condicaoPagamentoController', controller);
    controller.$inject = ['$scope', '$timeout', 'condicaoPagamentoService', '$alert', '$state'];

    function controller($scope, $timeout, condicaoPagamentoService, $alert, $state) {
        $scope.initializeLayout('Condições de Pagamento');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    ativo: null,
                    mercado: null,
                    percentualDescontoDe: null,
                    percentualDescontoAte: null,
                    valorMinimoDe: null,
                    valorMinimoAte: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    condicaoPagamentoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.state.salvando = false;
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.historyBack();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo)
                        $scope.popups.add.prepare();
                },
                prepare: function () {
                    condicaoPagamentoService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    }
                }
            }
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            condicaoPagamentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            condicaoPagamentoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            condicaoPagamentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.ativo = null;
            $scope.state.filtro.args.mercado = null,
                $scope.state.filtro.args.percentualDescontoDe = null,
                $scope.state.filtro.args.percentualDescontoAte = null,
                $scope.state.filtro.args.valorMinimoDe = null,
                $scope.state.filtro.args.valorMinimoAte = null,

                $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        /*Inicializa funções*/
        $scope.initialize();

    }

})();